function C=concurrence(rho)
% Usage: C=concurrence(rho)
%
% Returns the two-qubit concurrence of the density matrix rho or a
% two qubit state.

if(min(size(rho)) == 1)
	rho = psi * psi';
end

Z = [0 0 0 -1; 0 0 1 0; 0 1 0 0; -1 0 0 0];
R = rho * Z * rho.' * Z;
[right,r]=eig(R);
%left = inv(right);
r=real(diag(r));
tmp = sort(sqrt(r));
C = real(tmp(4) - tmp(3) - tmp(2) - tmp(1));
C = max(C, 0);

